
// $Id: Pepa.lex,v 1.6 1999/02/26 14:54:35 gcla Exp $

// file       	: Pepa.lex
// description	: Lexer for Pepa syntax
// project      : PEPAroni (mjta)
// author     	: Graham Clark
// Time-stamp	: <26 Feb 99 14:44:45 gcla>

package pepa.process;

import java.lang.System;
import pepa.process.PepaToken.*;
import pepa.process.Debug;

class PepaToken {
  case COMMA;
  case DOT;
  case TOP;
  case LPAREN;
  case RPAREN;
  case SEMI;
  case EQUALS;
  case PAR;
  case LCOOP;
  case RCOOP;
  case LSET;
  case RSET;
  case MULT;
  case MINUS;
  case SUM;
  case HIDE;
  case HASH;
  case PERC;
  case EXP;
  case NORM;
  case UNIF;
  case NUMB;
  case STRN;
  case PEOF;

  public boolean equals(PepaToken pt) {
    boolean res = false;
    switch (this) {
    case COMMA:
      switch (pt) {
      case COMMA: res = true; break;
      case _: res = false; break;
      } break;
    case DOT:
      switch (pt) {
      case DOT: res = true; break;
      case _: res = false; break;
      } break;
    case TOP:
      switch (pt) {
      case TOP: res = true; break;
      case _: res = false; break;
      } break;
    case LPAREN:
      switch (pt) {
      case LPAREN: res = true; break;
      case _: res = false; break;
      } break;
    case RPAREN:
      switch (pt) {
      case RPAREN: res = true; break;
      case _: res = false; break;
      } break;
    case SEMI:
      switch (pt) {
      case SEMI: res = true; break;
      case _: res = false; break;
      } break;
    case EQUALS:
      switch (pt) {
      case EQUALS: res = true; break;
      case _: res = false; break;
      } break;
    case PAR:
      switch (pt) {
      case PAR: res = true; break;
      case _: res = false; break;
      } break;
    case LCOOP:
      switch (pt) {
      case LCOOP: res = true; break;
      case _: res = false; break;
      } break;
    case RCOOP:
      switch (pt) {
      case RCOOP: res = true; break;
      case _: res = false; break;
      } break;
    case LSET:
      switch (pt) {
      case LSET: res = true; break;
      case _: res = false; break;
      } break;
    case RSET:
      switch (pt) {
      case RSET: res = true; break;
      case _: res = false; break;
      } break;
    case MULT:
      switch (pt) {
      case MULT: res = true; break;
      case _: res = false; break;
      } break;
    case MINUS:
      switch (pt) {
      case MINUS: res = true; break;
      case _: res = false; break;
      } break;
    case SUM:
      switch (pt) {
      case SUM: res = true; break;
      case _: res = false; break;
      } break;
    case HIDE:
      switch (pt) {
      case HIDE: res = true; break;
      case _: res = false; break;
      } break;
    case HASH:
      switch (pt) {
      case HASH: res = true; break;
      case _: res = false; break;
      } break;
    case PERC:
      switch (pt) {
      case PERC: res = true; break;
      case _: res = false; break;
      } break;
    case EXP:
      switch (pt) {
      case EXP: res = true; break;
      case _: res = false; break;
      } break;
    case NORM:
      switch (pt) {
      case NORM: res = true; break;
      case _: res = false; break;
      } break;
    case UNIF:
      switch (pt) {
      case UNIF: res = true; break;
      case _: res = false; break;
      } break;
    case NUMB:
      switch (pt) {
      case NUMB: res = true; break;
      case _: res = false; break;
      } break;
    case STRN:
      switch (pt) {
      case STRN: res = true; break;
      case _: res = false; break;
      } break;
    case PEOF:
      switch (pt) {
      case PEOF: res = true; break;
      case _: res = false; break;
      } break;
    }
    return res;
  }


//   public boolean equals(PepaToken pt) {
//     Debug.println(5, "testing equality.");
//     Debug.println(5, "this is a " + this.toString());
//     Debug.println(5, "pt arg is a " + pt.toString());

//     boolean answer = (this.getClass().isInstance(pt) &&
// 	    pt.getClass().isInstance(this));
//     if (answer) {
//       Debug.println(5, "answer was equal!");
//     } else {
//       Debug.println(5, "answer was not equal!");
//     }
//     return ((this instanceof pt.getClass()) &&
// 	    (pt instanceof this.getClass()));
//   }

  public String toString() {
    switch(this) {
    case COMMA:
      return "comma";
    case DOT:
      return "dot";
    case TOP:
      return "T";
    case LPAREN:
      return "lparen";
    case RPAREN:
      return "rparen";
    case SEMI:
      return "semi";
    case EQUALS:
      return "equals";
    case PAR:
      return "par";
    case LCOOP:
      return "lcoop";
    case RCOOP:
      return "rcoop";
    case LSET:
      return "lset";
    case RSET:
      return "rset";
    case MULT:
      return "times";
    case MINUS:
      return "minus";
    case SUM:
      return "sum";
    case HIDE:
      return "hide";
    case HASH:
      return "hash";
    case PERC:
      return "perc";
    case EXP:
      return "exp";
    case NORM:
      return "norm";
    case UNIF:
      return "unif";
    case NUMB:
      return "numb";
    case STRN:
      return "strn";
    case PEOF:
      return "peof";
    }
  }

  public int toInt() {
    switch(this) {
    case COMMA:
      return sym.COMMA;
    case DOT:
      return sym.DOT;
    case TOP:
      return sym.TOP;
    case LPAREN:
      return sym.LPAREN;
    case RPAREN:
      return sym.RPAREN;
    case SEMI:
      return sym.SEMI;
    case EQUALS:
      return sym.EQUALS;
    case PAR:
      return sym.PAR;
    case LCOOP:
      return sym.LCOOP;
    case RCOOP:
      return sym.RCOOP;
    case LSET:
      return sym.LSET;
    case RSET:
      return sym.RSET;
    case MULT:
      return sym.MULT;
    case MINUS:
      return sym.MINUS;
    case SUM:
      return sym.SUM;
    case HIDE:
      return sym.HIDE;
    case HASH:
      return sym.HASH;
    case PERC:
      return sym.PERC;
    case EXP:
      return sym.EXP;
    case NORM:
      return sym.NORM;
    case UNIF:
      return sym.UNIF;
    case NUMB:
      // may need changing later gcla
      return sym.NUMB;
    case STRN:
      return sym.STRN;
      // NOTE!!!! Not PEOF!!
    case PEOF:
      return sym.EOF;
    }
  }
}

class Utility {
  public static void assert
    (
     boolean expr
     )
      { 
	if (false == expr) {
	  throw (new Error("Error: Assertion failed."));
	}
      }
  
  private static final String errorMsg[] = {
    "Error: Unmatched end-of-comment punctuation.",
    "Error: Unmatched start-of-comment punctuation.",
    "Error: Unclosed string.",
    "Error: Illegal character."
    };
  
  public static final int E_ENDCOMMENT = 0; 
  public static final int E_STARTCOMMENT = 1; 
  public static final int E_UNCLOSEDSTR = 2; 
  public static final int E_UNMATCHED = 3; 

  public static void error
    (
     int code
     )
      {
	System.out.println(errorMsg[code]);
      }
}

class Yytoken {
  Yytoken 
    (
     PepaToken token,
     String text,
     int line,
     int charBegin,
     int charEnd
     )
      {
	m_token = token;
	m_text = new String(text);
	m_line = line;
	m_charBegin = charBegin;
	m_charEnd = charEnd;
      }

  public PepaToken m_token;
  public String m_text;
  public int m_line;
  public int m_charBegin;
  public int m_charEnd;
}

%%

%{
  private int comment_count = 0;
%} 
%line
%char
%state COMMENT
%state CPPCOMMENT

%eofval{ 
return new Yytoken(PEOF,"eof",-1,-1,-1);
%eofval} 

ALPHA=[A-Za-z]
DIGIT=[0-9]
NONNEWLINE_WHITE_SPACE_CHAR=[\ \t\b\012]
WHITE_SPACE_CHAR=[\n\ \t\b\012]
STRING_TEXT=(\\\"|[^\n\"]|\\{WHITE_SPACE_CHAR}+\\)*
COMMENT_TEXT=([^/*\n]|[^*\n]"/"[^*\n]|[^/\n]"*"[^/\n]|"*"[^/\n]|"/"[^*\n])*
CPPCOMMENT_TEXT=([^\n])*

NUMBER=[0-9]+(\.[0-9]*)?
NEWNUMBER=[0-9]

%% 

<YYINITIAL> "," { return (new Yytoken(COMMA,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "." { return (new Yytoken(DOT,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "infty" { return (new Yytoken(TOP,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "Exp" { return (new Yytoken(EXP,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "Norm" { return (new Yytoken(NORM,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "Uni" { return (new Yytoken(UNIF,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "T" { return (new Yytoken(TOP,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "(" {         Debug.println(5, "(Found a '(')");
return (new Yytoken(LPAREN,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> ")" { return (new Yytoken(RPAREN,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> ";" { Debug.println(5, "(Found a ';')");
return (new Yytoken(SEMI,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "=" { return (new Yytoken(EQUALS,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "||" { return (new Yytoken(PAR,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "<" { return (new Yytoken(LCOOP,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> ">" { return (new Yytoken(RCOOP,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "{" { return (new Yytoken(LSET,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "}" { return (new Yytoken(RSET,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "*" { return (new Yytoken(MULT,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "-" { return (new Yytoken(MINUS,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "+" { return (new Yytoken(SUM,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "/" { return (new Yytoken(HIDE,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "#" { Debug.println(5, "(Found a '#')");
return (new Yytoken(HASH,yytext(),yyline,yychar,yychar+1)); }
<YYINITIAL> "%" { Debug.println(5, "(Found a '%')");
return (new Yytoken(PERC,yytext(),yyline,yychar,yychar+1)); }

<YYINITIAL> {NONNEWLINE_WHITE_SPACE_CHAR}+ { }

<YYINITIAL,COMMENT,CPPCOMMENT> \n { }

<YYINITIAL> {NUMBER} {
        Debug.println(5, "(Found a number)" + yytext());
	return (new Yytoken(NUMB,yytext(),yyline,yychar,yychar + yytext().length()));
}

<YYINITIAL> {ALPHA}({ALPHA}|{DIGIT}|[_\-])* {
        Debug.println(5, "(Found a string)"+yytext());
	return (new Yytoken(STRN,yytext(),yyline,yychar,yychar + yytext().length()));
}	

<YYINITIAL> "//" { yybegin(CPPCOMMENT); }
<YYINITIAL> "/*" { yybegin(COMMENT); comment_count = comment_count + 1; }

<CPPCOMMENT> {CPPCOMMENT_TEXT} { yybegin(YYINITIAL); }

<COMMENT> "/*" { comment_count = comment_count + 1; }
<COMMENT> "*/" { 
	comment_count = comment_count - 1; 
	Utility.assert(comment_count >= 0);
	if (comment_count == 0) {
    		yybegin(YYINITIAL);
	}
}
<COMMENT> {COMMENT_TEXT} { }

<YYINITIAL,COMMENT,CPPCOMMENT> . {
        System.out.println("Illegal character: <" + yytext() + ">");
	Utility.error(Utility.E_UNMATCHED);
}







